var Timers = require("timers");

function ParseMoment(value) {
    var regex = value.match(/^(\d{1,2}):(\d{1,2})$/);
    var hour = 0;
    var minute = 0;
    if (regex != null) {
        hour = Number(regex[1]);
        minute = Number(regex[2]);
    }    
    return Timers.Moment(hour, minute);
}

function ParseDays(value) {
    var arr = value.split(',');
    return arr.map(function(item) {
        return Number(item);
    });
}
 
exports.Add = function (name, title, changeHandler) {
    if (changeHandler === undefined) {
        log('   {} -   [{}] !', name, changeHandler);
        return;
    }

    if (changeHandler == null) {
        log('   {} -  ', name);
        return;
    }

    log('   {}', name);

    defineVirtualDevice(
        name,
        {
            title: title,
            cells: {
                Active: {
                    type: "switch",
                    title: " ",
                    value: false,
                    readonly: false,
                    order: 1,
                },
                IsOn: {
                    type: "switch",
                    title: "",
                    value: false,
                    readonly: true,
                    order: 2
                },
                DayOfTheWeek: {
                    type: "text",
                    title: " ",
                    value: "1,2,3,4,5,6,7",
                    order: 3,
                    readonly: false
                },
                Start: {
                    type: "text",
                    title: "",
                    value: "08:00",
                    order: 4,
                    readonly: false
                },
                Stop: {
                    type: "text",
                    title: "",
                    value: "22:00",
                    order: 5,
                    readonly: false
                }
            }
        }
    );

    var active = name + "/Active";
    var timer = name + "Timer";

    var setValue = function (value) {
        changeHandler(value);
        dev[name + "/IsOn"] = value;
    }

    defineRule(name + "Active", {
        whenChanged: [active],
        then: function () {
            if (dev[active]) {
                Timers.Add(
                    timer,
                    ParseDays(dev[name + "/DayOfTheWeek"]),
                    ParseMoment(dev[name + "/Start"]),
                    ParseMoment(dev[name + "/Stop"]),
                    setValue
                );
            } else {
                Timers.Remove(timer);
                setValue(false);
            }
        }
    });
};