var Storage = [];
const Debug = false;

exports.EveryDay = function () {
	return [1, 2, 3, 4, 5, 6, 7];
};

exports.Moment = function (hour, minute) {
	return {
		Hour: hour,
		Minute: minute,
	}
};

exports.Add = function (name, dayOfTheWeek, start, stop, onSwitch) {
	if (Debug) log('  {}', name);
	Timers.Remove(name);
	Storage.push({
		Name: name,
		DayOfTheWeek: dayOfTheWeek,
		Start: start,
		Stop: stop,
		OnSwitch: onSwitch,
		State: null
	});
};

exports.Remove = function (name) {
	if (Debug) log('  {}', name);
	Storage = Storage.filter(function (el) { return el.Name != name; });
};

function ArrayContains(a, obj) {
	var i = a.length;
	while (i--) {
		if (a[i] === obj) {
			return true;
		}
	}
	return false;
}

function GetMinutes(time) {
	return time.Hour * 60 + time.Minute;
}

function OnEachTimer(timer) {
	var now = new Date();
	var day = now.getDay();
	if (day == 0) day = 7;
	var hour = now.getHours();
	var minute = now.getMinutes();

	if (Debug)
		log(
			'  {}  {}   {}  {} ',
			timer.Name,
			day,
			hour,
			minute
		);

	if (Debug)
		log(
			' {}    [{}]   ( {} )  {}:{}  {}:{} !',
			timer.Name,
			timer.DayOfTheWeek,
			timer.DayOfTheWeek.length,
			timer.Start.Hour,
			timer.Start.Minute,
			timer.Stop.Hour,
			timer.Stop.Minute
		);

	var start = GetMinutes(timer.Start);
	var stop = GetMinutes(timer.Stop);
	var moment = GetMinutes(Timers.Moment(hour, minute));
	var dayOn = ArrayContains(timer.DayOfTheWeek, day);
	var value = dayOn && (start <= moment) && (moment < stop);
	if (Debug)
		log(
			' {}  {}  {}',
			moment,
			start,
			stop
		);

	if (timer.State != null) {
		if (timer.State == value) {
			return;
		}
	}

	if (Debug) log('  {}', value);
	timer.State = value;

	if ((timer.OnSwitch !== undefined) && (timer.OnSwitch != null)) {
		timer.OnSwitch(value);
	}
	else {
		log('  {} -  ', timer.Name);
	}
}

defineRule("TimersTick", {
	when: function () {
		return timers.TimersTick.firing
	},
	then: function () {
		if (Debug) log('   {} ', Timers.Storage.length);
		Storage.forEach(OnEachTimer);
	}
});

startTicker("TimersTick", 5000);